/**
 * description
 *
 * @author eson
 *2022年7月20日-10:00:05
 */
package com.yuandian.dataflow.statemachine;

import java.time.Instant;
import java.util.List;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.function.Consumer;

import com.alipay.sofa.jraft.Status;
import com.alipay.sofa.jraft.error.RemotingException;
import com.alipay.sofa.jraft.rpc.InvokeCallback;
import com.google.protobuf.Any;
import com.yuandian.dataflow.controller.PacketsProcessor.PacketsRequest;
import com.yuandian.dataflow.proto.msgtype.BacktrackingFlowOuterClass;
import com.yuandian.dataflow.statemachine.closure.GenericClosure;
import com.yuandian.dataflow.statemachine.master.MasterContext;
import com.yuandian.dataflow.statemachine.master.MasterExecute;
import com.yuandian.dataflow.statemachine.operate.Operate;
import com.yuandian.dataflow.statemachine.operate.Operate.OperateType;
import com.yuandian.dataflow.statemachine.state.State;
import com.yuandian.dataflow.statemachine.state.WorkerState;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import lombok.extern.slf4j.Slf4j;

/**
 * Master主线程, 用于接收packets
 *
 * @author eson
 *         2022年7月20日-10:00:05
 */
@Slf4j
@Getter
@Setter
@ToString
public class MasterFactory {
 
    private static MasterExecute masterExecuteCls; 
    
    public static void registerMasterLoop(MasterExecute masterExecute) {
        if(masterExecuteCls != null) {
            log.error("registerMasterLoop is registed");
        }
        masterExecuteCls = masterExecute;
    }

    public static Thread masterExecuteThread = new Thread(new Runnable() {
        @Override
        public void run() {
             
            MasterContext cxt = new MasterContext();
            while (!cxt.getIsExit()) {
                masterExecuteCls.loop(cxt);
            }
 
        }
    });

    public static Thread getMasterExecute() {
        return masterExecuteThread;
    }

    public static void Init() {

    }

}
